# encoding: utf-8
# Author: Lu Zhengyang <luzhengyang1995@gmail.com>
import os
import re
class 	PATCH:
	def __init__(self):
		raw_input(unicode('在使用之前，请确认你的电脑安装了JAVA环境，PYTHON2.7版本，确定在CMD窗口中输入 JAR '
				'\nJAVA PYTHON这三个命令系统都会有反应\n    因为本程序所造成的任何损失，后果自负【回车键继续】\n', 'utf-8').encode('gbk'))
		raw_input(unicode('\n这个程序是我抽空写的，目前处于完善阶段，最终会实现一键打补丁，并且直接将补丁推送到手机，'
						  '目前只实现了程序自动导出services.jar并且打补丁，需要您手动替换系统的services.jar文件\n\n请将手机开启USB调试连接电脑【回车键继续】\n', 'utf-8').encode('gbk'))
		self.dir = os.getcwd()
		self.adb_dir = self.dir + "\\adb\\adb.exe"
		self.services_jar = self.dir + "\\framework\\services.jar"
		self.services_64_odex = self.dir + "\\framework\\oat\\arm64\\services.odex"
		self.boot_64_oat_dir = self.dir + "\\framework\\arm64"
		self.services_dex_dir = self.dir + "\\framework\\dex"
	def adb_connect(self):
		print u"初始化环境并连接手机中......"
		os.popen('taskkill /f /im adb.exe')
		adb_dir = self.dir+"\\adb\\adb.exe"
		adb_start = os.popen(adb_dir+" devices").read()
		connect_success = re.findall("devices[\s\S]*device",adb_start)
		if connect_success:
			print u"连接手机成功，下面进行提取手机文件"
			self.get_framework()
		else:
			raw_input(unicode('手机连接失败，请确认安装了驱动,打开了ADB调试模式，并且在手机上面允许电脑进行调试，【回车键继续】', 'utf-8').encode('gbk'))
			os.popen('taskkill /f /im adb.exe')

	def get_framework(self):
		file = os.popen(self.adb_dir+" pull /system/framework").read()
		print file
		services_jar = self.check_file(self.services_jar)
		services_odex = self.check_file(self.services_64_odex)
		if services_odex:
			print u"检测到你的设备是odex化设备，请选择你的安卓版本....."
			android_ver = raw_input(unicode('如果为安卓5.0-5.1设备请输入1\n如果为安卓6.0-7.1设备请输入2\n', 'utf-8').encode('gbk'))
			if android_ver == "1":
				self.android_ver_5()
			else:
				if  android_ver == "2":
					self.android_ver_7()
				else:
					print u"输入错误。"
		else :
			raw_input( unicode('\n检测到为非ODEX化系统【回车键继续】','utf-8').encode('gbk'))
			self.only_services_jar()


	def check_file(self,file):
		available = os.path.exists(file)
		return available

	def only_services_jar(self):
		print u"提取services.jar中...."
		os.popen("java -Xms1g -jar baksmali-2.2b4.jar d "+self.services_jar+" -o services").read()
		print u"提取成功"
		self.patch_py()
	def android_ver_5(self):
		raw_input(unicode('现在选择的版本为安卓5.0-安卓5.1 odex化，【请按回车键继续】', 'utf-8').encode('gbk'))
		print os.popen("java -Xms1g -jar oat2dex.jar boot "+self.boot_64_oat).read()
		print os.popen("java -Xms1g -jar oat2dex.jar "+self.services_64_odex+" "+self.services_dex_dir).read()
		print os.popen("java -Xms1g -jar baksmali-2.2b4.jar d "+self.services_dex+" -o services").read()
		self.patch_py()

	def android_ver_7(self):
		raw_input(unicode('【现在选择的版本为安卓6.0-7.1，请按回车键继续】', 'utf-8').encode('gbk'))
		print os.popen("java -Xms1g -jar baksmali-2.2b4.jar x -d "+self.boot_64_oat_dir+" "+self.services_64_odex+" -o services").read()
		self.patch_py()

	def patch_py(self):
		print u"下面调用官方的patch.py文件进行打补丁\n\n\n【千万不要按任何按键！！！！！】...\n\n"
		print u'【\n'
		os.system("python patch.py -a apk -s services")
		print u"\n】\n\n请仔细查看本内容中是否存在打补丁字样，正常的话，Android 4.4 一共有 14 处补丁，5.0 以上共有 15 处补丁。"
		self.putout_patch()
	def putout_patch(self):
		os.popen("java -Xms1g -jar smali-2.2b4.jar a -o classes.dex services")
		print os.popen("jar -cvf services.jar classes.dex").read()
		os.popen('taskkill /f /im adb.exe')
		raw_input(unicode('现在，补丁完成，请做好备份，使用新生成的services.jar替换设备中的/system/framework/services.jar，并删除设备中的所有services.odex，安装黑域，重启。请一定要做好备份\n\n\n【如果需要安装手机端的黑域的话，请按回车键，否则请关闭】。', 'utf-8').encode('gbk'))
		self.install_pr()
	def install_pr(self):
		print os.popen(self.adb_dir+" install pr-v3.1.1.apk").read()
		raw_input(unicode('安装成功', 'utf-8').encode('gbk'))




if __name__ == '__main__':
	PATCH().adb_connect()


